package pobyty.akce;

import java.util.List;
import java.util.Map;
import org.smp.SmpException;
import org.smp.actions.AbstractWebAction;
import pobyty.business.Facade;
import pobyty.model.doprovod.Doprovod;
import pobyty.model.doprovod.DoprovodId;

public abstract class AbstractPobytyAkce extends AbstractWebAction {

    protected DoprovodId findDoprovod(Map<String, Object> errorsMap) throws SmpException {
        String doprovodPar = getParameter("doprovodId");
        String prijmeni = getParameter("prijmeni");
        String jmeno = getParameter("jmeno");
        if (!doprovodPar.isEmpty()) {
            DoprovodId doprovodId = validateItem(DoprovodId.class, errorsMap);
            if (!errorsMap.isEmpty()) {
                return null;
            }
            Doprovod doprovod = Facade.getInstance().findDoprovod(doprovodId);
            if (doprovod == null) {
                errorsMap.put("errorDoprovodId", "Zadan\u00fd doprovod neexistuje");
                return null;
            } else {
                return doprovod.getDoprovodId();
            }

        } else if (!prijmeni.isEmpty() || !jmeno.isEmpty()) {
            List<Doprovod> doprovody = Facade.getInstance().doprovody(prijmeni, jmeno);
            if (doprovody.isEmpty()) {
                errorsMap.put("errorDoprovody", "Zadan\u00fd doprovod neexistuje");
                return null;
            } else if (doprovody.size() > 1) {
                errorsMap.put("errorDoprovody", "Zad\u00e1n\u00ed odpov\u00edd\u00e1 v\u00edce doprovod\u016fm");
                return null;
            } else {
                return doprovody.get(0).getDoprovodId();
            }

        } else {
            return null;
        }
    }
}
