package pobyty.akce.klientcast;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.ServletException;
import org.smp.SmpException;
import org.smp.pages.Page;
import pobyty.akce.AbstractPobytyAkce;
import pobyty.business.Facade;
import pobyty.model.Poznamka;
import pobyty.model.Prijmeni;
import pobyty.model.klient.Klient;
import pobyty.model.klient.KlientId;
import pobyty.model.prihlaska.Prihlaska;
import pobyty.model.turnus.TurnusId;

public class EvidovanyKlientFormularAkce extends AbstractPobytyAkce {

    @Override
    public void execute() throws ServletException, IOException, SmpException {
        Map<String, Object> errorsMap = new HashMap<>();
        KlientId klientId = validateItem(KlientId.class, errorsMap);
        Prijmeni prijmeni = validateItem(Prijmeni.class, errorsMap);
        if (errorsMap.isEmpty()) {
            Klient klient = Facade.getInstance().findKlient(klientId);
            if (klient == null) {
                errorsMap.put("error", "Klikent není evidován.");
            } else if (!klient.getPrijmeni().equals(prijmeni)) {
                errorsMap.put("error", "Evidenční číslo nesouhlasí s příjmením.");
            } else {
                Prihlaska prihlaska = Facade.getInstance().findPrihlaska(klientId);
                if (prihlaska != null) {
                    errorsMap.put("error", "Klient je již přihlášen.");
                }
            }
        }
        if (errorsMap.isEmpty()) {
            TurnusId turnusId = validateItem(TurnusId.class, errorsMap);
            Poznamka poznamka = validateItem(Poznamka.class, errorsMap);
            if (errorsMap.isEmpty()) {
                Facade.getInstance().addPrihlaska(klientId, turnusId, poznamka);                
                Page pageBean = createPageBean("/klientcast/PotvrzeniFormular.xhtml");
                pageBean.putItem("klientId", klientId);
                forward(pageBean);
            }
        }
        Page pageBean = createPageBean("/klientcast/EvidovanyKlientFormular.xhtml");
        requestParamsToMap(errorsMap);
        pageBean.pushBean(errorsMap);
        forward(pageBean);
    }
}
