package pobyty.akce.klientcast;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.ServletException;
import org.smp.SmpException;
import org.smp.pages.Page;
import pobyty.akce.AbstractPobytyAkce;
import pobyty.business.Facade;
import pobyty.model.Prijmeni;
import pobyty.model.klient.Klient;
import pobyty.model.klient.KlientId;
import pobyty.stranky.klientcast.EditFormular;

public class VyhledatFormularAkce extends AbstractPobytyAkce {

    @Override
    public void execute() throws ServletException, IOException, SmpException {
        Map<String, Object> errorsMap = new HashMap<>();
        KlientId klientId = validateItem(KlientId.class, errorsMap);
        Prijmeni prijmeni = validateItem(Prijmeni.class, errorsMap);
        if (errorsMap.isEmpty()) {
            Klient klient = Facade.getInstance().findKlient(klientId);
            if (klient == null) {
                errorsMap.put("error", "Klient není evidován.");
            } else if (!klient.getPrijmeni().equals(prijmeni)) {
                errorsMap.put("error", "Evidenční číslo nesouhlasí s příjmením.");
            }
        }
        if (errorsMap.isEmpty()) {
            EditFormular pageBean = (EditFormular) createPageBean("/klientcast/EditFormular.xhtml");
            pageBean.putItem("klientId", klientId);
            forward(pageBean);
        } else {
            Page pageBean = createPageBean("/klientcast/VyhledatFormular.xhtml");
            pageBean.pushBean(errorsMap);
            requestParamsToMap(errorsMap);
            forward(pageBean);
        }

    }
}
