package pobyty.akce.referentcast;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.ServletException;
import org.smp.SmpException;
import org.smp.pages.Page;
import pobyty.Parametry;
import pobyty.akce.AbstractPobytyAkce;
import pobyty.business.Facade;
import pobyty.model.uzivatel.Heslo;
import pobyty.model.uzivatel.Username;
import pobyty.model.uzivatel.Uzivatel;

public class LoginAkce extends AbstractPobytyAkce {

    public boolean login(Uzivatel user, String passwMD5) throws SmpException {
        String hesloMD5 = user.getHeslo().getHesloMDP();
        if (hesloMD5.equals(passwMD5)) {
            getRequest().getSession().setAttribute(Uzivatel.USER, user);
            return true;
        } else {
            return false;
        }
    }

    public void loginKoordinator() {
        getRequest().getSession().setAttribute(Uzivatel.USER, Uzivatel.KOORDINATOR);
    }

    @Override
    public void execute() throws ServletException, IOException, SmpException {
        Map<String, Object> errorsMap = new HashMap<>();

        Username username = validateItem(Username.class, errorsMap);
        String passwMD5 = Heslo.md5(getParameter("password"));
        if (errorsMap.isEmpty()) {
            if (Uzivatel.KOORDINATOR.getUsername().equals(username)) {
                String coordinatorpasswordHash = Parametry.getInstance().getParameter("koordinatorHeslo");
                if (coordinatorpasswordHash.equals(passwMD5)) {
                    loginKoordinator();
                } else {
                    errorsMap.put("errorHeslo", "Chybné heslo.");
                }
            } else {
                Uzivatel user = Facade.getInstance().findUzivatel(username);
                if (user == null) {
                    errorsMap.put("errorUsername", "Neznámý uživatel.");
                }
                if (errorsMap.isEmpty() && !login(user, passwMD5)) {
                    errorsMap.put("errorHeslo", "Chybné heslo.");
                }
            }
        }
        if (errorsMap.isEmpty()) {
            redirect("/referentcast/ReferentHlavni.xhtml");
        } else {
            Page page = createPageBean("/referentcast/LoginForm.xhtml");
            requestParamsToMap(errorsMap);
            page.pushBean(errorsMap);
            forward(page);
        }
    }
}
