package pobyty.akce.referentcast.doprovod;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.ServletException;
import org.smp.SmpException;
import pobyty.akce.AbstractPobytyAkce;
import pobyty.business.Facade;
import pobyty.model.Datum;
import pobyty.model.Jmeno;
import pobyty.model.Mejl;
import pobyty.model.Mesto;
import pobyty.model.OsobaAdresa;
import pobyty.model.Prijmeni;
import pobyty.model.Psc;
import pobyty.model.Telefon;
import pobyty.model.Ulice;
import pobyty.stranky.referentcast.doprovod.AddDoprovod;

public class PridatDoprovodAkce extends AbstractPobytyAkce {

    @Override
    public void execute() throws ServletException, IOException, SmpException {
        Map<String, Object> errorsMap = new HashMap<>();
        Prijmeni prijmeni = validateItem(Prijmeni.class, errorsMap);
        Jmeno jmeno = validateItem(Jmeno.class, errorsMap);
        Datum narozeni = validateItem(Datum.class, errorsMap, OsobaAdresa.COLUMN_NAROZENI);
        Mejl mejl = validateItem(Mejl.class, errorsMap);
        Ulice ulice = validateItem(Ulice.class, errorsMap);
        Psc psc = validateItem(Psc.class, errorsMap);
        Mesto mesto = validateItem(Mesto.class, errorsMap);
        Telefon telefon = validateItem(Telefon.class, errorsMap);
        if (errorsMap.isEmpty()) {
            Facade.getInstance().addDoprovod(prijmeni, jmeno, narozeni, mejl, ulice, psc, mesto, telefon);
            redirect("/referentcast/doprovod/TabDoprovod.xhtml");
        } else {
            AddDoprovod pageBean = (AddDoprovod) createPageBean("/referentcast/doprovod/AddDoprovod.xhtml");
            requestParamsToMap(errorsMap);
            pageBean.pushBean(errorsMap);
            forward(pageBean);
        }
    }
}
