package pobyty.akce.referentcast.prihlaska;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.ServletException;
import org.smp.SmpException;
import org.smp.pages.Page;
import pobyty.akce.AbstractPobytyAkce;
import pobyty.business.Facade;
import pobyty.model.Poznamka;
import pobyty.model.klient.KlientId;
import pobyty.model.prihlaska.StavPrihlasky;

public class ZaraditPrihlaskaAkce extends AbstractPobytyAkce {

    @Override
    public void execute() throws ServletException, IOException, SmpException {

        Map<String, Object> errorsMap = new HashMap<>();
        KlientId klientId = new KlientId(getParameter("klientId"));
        Poznamka pozn = validateItem(Poznamka.class, errorsMap);
        if (errorsMap.isEmpty()) {
            Facade.getInstance().updatePrihlaska(klientId, StavPrihlasky.ZARAZEN, pozn);
            redirect("/referentcast/prihlaska/TabSchvaleniKlienti.xhtml");
        } else {
            Page page = createPageBean("/referentcast/prihlaska/SchvalovaniPrihlasky.xhtml");
            requestParamsToMap(errorsMap);
            page.pushBean(errorsMap);
            forward(page);
        }
    }
}
