package pobyty.akce.referentcast.skupina;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.ServletException;
import org.smp.SmpException;
import org.smp.pages.Page;
import pobyty.akce.AbstractPobytyAkce;
import pobyty.business.Facade;
import pobyty.model.doprovod.DoprovodId;
import pobyty.model.skupina.Skupina;
import pobyty.model.skupina.SkupinaId;

public class ZmenaDoprovoduSkupinyAkce extends AbstractPobytyAkce {

    @Override
    public void execute() throws ServletException, IOException, SmpException {
        SkupinaId skupinaId = new SkupinaId(getIntParameter("skupinaId"));
        Skupina skupina = Facade.getInstance().findSkupina(skupinaId);
        Map<String, Object> errorsMap = new HashMap<>();
        DoprovodId doprovodId = findDoprovod(errorsMap);
        if (errorsMap.isEmpty()) {
            Facade.getInstance().updateSkupina(skupinaId, doprovodId);
            redirect("/referentcast/turnus/skupina/TabSkupina.xhtml?turnusId=" + skupina.getTurnusId());
        } else {
            Page page = createPageBean("/referentcast/turnus/skupina/EditDoprovodSkupiny.xhtml");
            requestParamsToMap(errorsMap);
            page.pushBean(errorsMap);
            forward(page);
        }
    }
}
