package pobyty.akce.referentcast.uzivatel;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.ServletException;
import org.smp.SmpException;
import pobyty.akce.AbstractPobytyAkce;
import pobyty.business.Facade;
import pobyty.model.Jmeno;
import pobyty.model.Prijmeni;
import pobyty.model.uzivatel.Heslo;
import pobyty.model.uzivatel.RoleUzivatele;
import pobyty.model.uzivatel.Username;
import pobyty.model.uzivatel.Uzivatel;
import pobyty.stranky.referentcast.uzivatel.AddUzivatel;

public class PridatUzivatelAkce extends AbstractPobytyAkce {

    @Override
    public void execute() throws ServletException, IOException, SmpException {
        Map<String, Object> errorsMap = new HashMap<>();
        Username username = validateItem(Username.class, errorsMap);
        if (username.equals(Uzivatel.KOORDINATOR.getUsername())) {
            errorsMap.put("errorUsername", "Username nesmí být \"korodinator\" ");
        }
        Prijmeni prijmeni = validateItem(Prijmeni.class, errorsMap);
        Jmeno jmeno = validateItem(Jmeno.class, errorsMap);
        RoleUzivatele roleUzivatele = validateItem(RoleUzivatele.class, errorsMap);
        Heslo heslo = validateItem(Heslo.class, errorsMap);
        Heslo overeni = validateItem(Heslo.class, errorsMap, "overeniHesla");
        if (heslo != null && !heslo.equals(overeni)) {
            errorsMap.put("errorOvereniHesla", "Nesouhlasí ověření hesla.");
        }
        if (errorsMap.isEmpty() && Facade.getInstance().findUzivatel(username) != null) {
            errorsMap.put("errorUsername", "Username je již použit.");
        }
        if (errorsMap.isEmpty()) {
            Facade.getInstance().addUzivatel(username, prijmeni, jmeno, roleUzivatele, heslo);
            redirect("/referentcast/uzivatel/TabUzivatel.xhtml");
        } else {
            AddUzivatel pageBean = (AddUzivatel) createPageBean("/referentcast/uzivatel/AddUzivatel.xhtml");
            requestParamsToMap(errorsMap);
            pageBean.pushBean(errorsMap);
            forward(pageBean);
        }
    }
}
