package pobyty.akce.referentcast.uzivatel;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.ServletException;
import org.smp.SmpException;
import pobyty.akce.AbstractPobytyAkce;
import pobyty.business.Facade;
import pobyty.model.uzivatel.Heslo;
import pobyty.model.uzivatel.Username;
import pobyty.stranky.referentcast.uzivatel.ZmenaHesla;

public class ZmenaHeslaAkce extends AbstractPobytyAkce {

    @Override
    public void execute() throws ServletException, IOException, SmpException {
        Map<String, Object> errorsMap = new HashMap<>();
        Username username = new Username(getParameter("username"));
        Heslo heslo = validateItem(Heslo.class, errorsMap);
        Heslo overeni = validateItem(Heslo.class, errorsMap, "overeniHesla");
        if (errorsMap.isEmpty() && !heslo.equals(overeni)) {
            errorsMap.put("errorOvereniHesla", "Nesouhlasí ověření hesla.");
        }
        if (errorsMap.isEmpty()) {
            Facade.getInstance().zmenitHeslo(username, heslo);
            redirect("/referentcast/uzivatel/TabUzivatel.xhtml");
        } else {
            ZmenaHesla page = (ZmenaHesla) createPageBean("/referentcast/uzivatel/ZmenaHesla.xhtml");
            requestParamsToMap(errorsMap);
            page.pushBean(errorsMap);
            forward(page);
        }
    }
}
