package pobyty.business;

import java.sql.SQLException;

public class DefaultDAOFactory implements PobytyDAOFactory {

    @Override
    public UzivatelDAO createUzivatelDAO() {
        return new UzivatelDAOImpl();
    }

    @Override
    public PrihlaskaDAO createPrihlaskaDAO() {
        return new PrihlaskaDAOImpl();
    }

    @Override
    public SkupinaDAO createSkupinaDAO() {
        return new SkupinaDAOImpl();
    }

    @Override
    public TurnusDAO createTurnusDAO() {
        return new TurnusDAOIml();
    }

    @Override
    public KlientDAO createKlientDAO() {
        return new KlientDAOImpl();
    }

    @Override
    public DoprovodDAO createDoprovodDAO() throws SQLException {
        return new DoprovodDAOImpl();
    }
}
