package pobyty.business;

import java.util.List;
import org.smp.SmpException;
import pobyty.model.Poznamka;
import pobyty.model.PrihlaskaKlient;
import pobyty.model.klient.KlientId;
import pobyty.model.prihlaska.Prihlaska;
import pobyty.model.prihlaska.StavPrihlasky;
import pobyty.model.skupina.SkupinaId;
import pobyty.model.turnus.TurnusId;

public interface PrihlaskaDAO {

    void add(KlientId klientId, TurnusId turnusId, Poznamka poznamka) throws SmpException;

    Prihlaska find(KlientId klientId) throws SmpException;

    List<Prihlaska> all() throws SmpException;

    List<Prihlaska> all(SkupinaId skupinaId) throws SmpException;

    void update(KlientId klientId, TurnusId turnusId, StavPrihlasky stavPrihlasky, Poznamka poznamka) throws SmpException;

    void update(KlientId klientId, TurnusId turnusId, Poznamka poznamka) throws SmpException;

    void update(KlientId klientId, StavPrihlasky stavPrihlasky, Poznamka poznamka) throws SmpException;

    void update(KlientId klientId, SkupinaId skupinaId) throws SmpException;

    void delete(KlientId id) throws SmpException;

    int clientsCount(SkupinaId skupinaId) throws SmpException;

    int clientsCount(TurnusId turnusId) throws SmpException;

    List<PrihlaskaKlient> prihlaskaKlientJoin() throws SmpException;

    List<PrihlaskaKlient> prihlaskaKlientJoin(StavPrihlasky stavPrihlasky) throws SmpException;

    List<PrihlaskaKlient> prihlaskaKlientJoin(TurnusId turnusId) throws SmpException;

    List<PrihlaskaKlient> prihlaskaKlientJoin(SkupinaId skupinaId) throws SmpException;
}
