package pobyty.business;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import pobyty.model.doprovod.DoprovodId;
import pobyty.model.skupina.Skupina;
import pobyty.model.skupina.SkupinaId;
import pobyty.model.skupina.VekKlientu;
import pobyty.model.turnus.TurnusId;

class SkupinaDAOImpl implements SkupinaDAO {

    private Map<SkupinaId, Skupina> skupiny = new TreeMap<>();
    static int counter;

    public SkupinaDAOImpl() {
    }

    @Override
    public Skupina find(SkupinaId id) {
        Skupina s = skupiny.get(id);
        return s;
    }

    private void putSkupina(Skupina s) {
        skupiny.put(s.getSkupinaId(), s);
    }

    @Override
    public void add(TurnusId turnusId, VekKlientu vekKlientu, DoprovodId doprovodId) {
        putSkupina(new Skupina(new SkupinaId(++counter), turnusId, vekKlientu, doprovodId));
    }

    @Override
    public List<Skupina> all(TurnusId turnusId) {
        List<Skupina> skupinyTurnusu = new ArrayList<>();
        for (Skupina skupina : skupiny.values()) {
            if (skupina.getTurnusId().equals(turnusId)) {
                skupinyTurnusu.add(skupina);
            }
        }
        return skupinyTurnusu;
    }

    @Override
    public void delete(SkupinaId skupinaId) {
        skupiny.remove(skupinaId);
    }

    @Override
    public void update(SkupinaId skupinaId, DoprovodId doprovodId) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
