package pobyty.business;

import java.util.List;
import org.smp.SmpException;
import pobyty.model.Datum;
import pobyty.model.PobytyIntegrityException;
import pobyty.model.turnus.Cena;
import pobyty.model.turnus.Kapacita;
import pobyty.model.turnus.Lokalita;
import pobyty.model.turnus.Turnus;
import pobyty.model.turnus.TurnusId;
import pobyty.model.turnus.Zkratka;

public interface TurnusDAO {

    void add(Datum zacatek, Datum konec, Lokalita lokalita, Cena cena, Kapacita kapacita, Zkratka zkratka) throws SmpException;

    Turnus find(TurnusId turnusId) throws SmpException;

    public List<Turnus> all() throws SmpException;

    void update(TurnusId turnusId, Zkratka zkratka, Datum zacatek, Datum konec, Lokalita lokalita, Cena cena, Kapacita kapacita) throws SmpException;

    void delete(TurnusId turnusId) throws SmpException, PobytyIntegrityException;
}
