package pobyty.business;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import pobyty.model.Jmeno;
import pobyty.model.Prijmeni;
import pobyty.model.uzivatel.Heslo;
import pobyty.model.uzivatel.RoleUzivatele;
import pobyty.model.uzivatel.Username;
import pobyty.model.uzivatel.Uzivatel;

final class UzivatelDAOImpl implements UzivatelDAO {

    private Map<Username, Uzivatel> uzivatele = new HashMap<>();

    @Override
    public Uzivatel find(Username username) {
        return uzivatele.get(username);
    }

    @Override
    public void add(Username username, Prijmeni prijmeni, Jmeno jmeno, RoleUzivatele roleUzivatele, Heslo heslo) {
        add(new Uzivatel(username, prijmeni, jmeno, roleUzivatele, heslo));
    }

    public final Username add(Uzivatel uzivatel) {
        uzivatele.put(uzivatel.getUsername(), uzivatel);
        return uzivatel.getUsername();
    }

    @Override
    public List<Uzivatel> all() {
        return new ArrayList<>(uzivatele.values());
    }

    @Override
    public void delete(Username username) {
        uzivatele.remove(username);
    }

    @Override
    public void update(Username username, Heslo heslo) {
        find(username).setHeslo(heslo);
    }
}
