package pobyty.model;

import javax.validation.ValidationException;

public class AbstrId implements Comparable<AbstrId> {

    public static int validateId(String idStr) throws ValidationException {
        try {
            return Integer.parseInt(idStr);
        } catch (NumberFormatException ex) {
            throw new ValidationException("Chybné ID.");
        }
    }
    private int id;

    public AbstrId(int id) {
        this.id = id;
    }

    public int getAbstrtId() {
        return id;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (!(obj instanceof AbstrId)) {
            return false;
        }
        return compareTo((AbstrId) obj) == 0;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 29 * hash + this.id;
        return hash;
    }

    @Override
    public int compareTo(AbstrId o) {
        return id - o.id;
    }

    @Override
    public String toString() {
        return Integer.toString(id);
    }
}
