package pobyty.model;

import java.util.Objects;
import javax.validation.ValidationException;

public class Mejl {

    public static int MEJL_SIZE = 30;

    public static String colName() {
        return Mejl.class.getSimpleName();
    }

    public static Mejl validate(String mejl) throws ValidationException {
        if (mejl == null) {
            throw new ValidationException("Prosím vyplňte e-mail.");
        }
        mejl = mejl.trim();
        if (mejl.isEmpty()) {
            throw new ValidationException("Prosím vyplňte e-mail.");
        }
        if (mejl.length() > MEJL_SIZE) {
            throw new ValidationException(String.format("E-mail může být maximálně %d znaků.", MEJL_SIZE));
        }
        return new Mejl(mejl);
    }
    private String mejl;

    public Mejl(String mejl) {
        this.mejl = mejl;
    }

    /**
     * @return the mejl
     */
    public String getMejl() {
        return mejl;
    }

    @Override
    public String toString() {
        return mejl;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }

        return mejl.equals(((Mejl) obj).getMejl());
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 97 * hash + Objects.hashCode(this.mejl);
        return hash;
    }
}
