package pobyty.model;

import java.util.Objects;
import javax.validation.ValidationException;

public class Poznamka {

    public static int POZNAMKA_SIZE = 200;

    public static String colName() {
        return Poznamka.class.getSimpleName();
    }
    private String poznamka = "";

    public Poznamka(String poznamka) {
        this.poznamka = poznamka;
    }

    public static Poznamka validate(String poznamka) throws ValidationException {
        if (poznamka == null) {
            poznamka = "";
        }
        poznamka = poznamka.trim();
        if (poznamka.length() > POZNAMKA_SIZE) {
            throw new ValidationException(String.format("Poznámka může být maximálně %d znaků (%d).", POZNAMKA_SIZE, poznamka.length()));
        }
        return new Poznamka(poznamka);
    }

    @Override
    public String toString() {
        return poznamka;
    }

    public String getPoznamka() {
        return poznamka;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }

        return poznamka.equals(((Poznamka) obj).getPoznamka());
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 97 * hash + Objects.hashCode(this.poznamka);
        return hash;
    }
}
