package pobyty.model;

import java.util.Objects;
import org.smp.ValidationException;

public class Telefon {

    public static final int TELEFON_SIZE = 9;

    public static String colName() {
        return Telefon.class.getSimpleName();
    }

    public static Telefon validate(String telefon) throws ValidationException {
        if (telefon == null) {
            throw new ValidationException("Prosím vyplňte číslo telefonu.");
        }
        telefon = telefon.trim();
        if (telefon.isEmpty()) {
            throw new ValidationException("Prosím vyplňte číslo telefonu.");
        }
        if (telefon.length() > TELEFON_SIZE) {
            throw new ValidationException(String.format("Číslo telefonu může být maximálně %d čísel.", TELEFON_SIZE));
        }
        return new Telefon(telefon);
    }
    private String telefon;

    public Telefon(String telefon) {
        this.telefon = telefon;
    }

    @Override
    public String toString() {
        return telefon;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }

        return telefon.equals(((Telefon) obj).getTelefon());
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 37 * hash + Objects.hashCode(this.telefon);
        return hash;
    }

    public String getTelefon() {
        return telefon;
    }
}
