package pobyty.model.prihlaska;

import org.smp.SetPage;
import org.smp.SmpException;
import org.smp.ValidationException;
import org.smp.pages.Page;

public enum StavPrihlasky implements SetPage {

    PRIHLASEN,
    SCHVALEN,
    ZARAZEN,
    ODMITNUT;

    public static int size() {
        int size = 0;
        for (StavPrihlasky i : values()) {
            size = Math.max(size, i.toString().length());
        }
        return size;
    }

    public static String colName() {
        return StavPrihlasky.class.getSimpleName();
    }

    public static StavPrihlasky validate(String value) throws ValidationException {
        try {
            return valueOf(value);
        } catch (IllegalArgumentException ex) {
            throw new ValidationException(ex.toString());
        }
    }
    private Page page;

    public String getStavPrihlaskyId() {
        return super.toString();
    }

    @Override
    public String toString() {
        switch (this) {
            case PRIHLASEN:
                return "přihlášen";
            case ZARAZEN:
                return "zařazen";
            case SCHVALEN:
                return "schválen";
            case ODMITNUT:
                return "zrušen";
        }
        return super.toString();
    }

    public boolean getSelectedStavPrihlasky() throws SmpException {
        Object item = page.getItem("stavPrihlasky");
        if (item instanceof StavPrihlasky) {
            return this == item; // item  z pageBean
        } else {
            return getStavPrihlaskyId().equals(item);  // item z requestu
        }

    }

    @Override
    public void setPage(Page page) {
        this.page = page;
    }
}
