package pobyty.model.skupina;

import org.smp.ValidationException;

public class VekKlientu {

    public static final int VEKKLIENTU_SIZE = 4;
    public static final int MIN_VEK = 6;
    public static final int MAX_VEK = 16;
    private static final String CHYBA = "Věk musí být od " + MIN_VEK + " do " + MAX_VEK + " let.";

    public static String colName() {
        return VekKlientu.class.getSimpleName();
    }

    public static VekKlientu validate(String vekVeSkupineStr) throws ValidationException {
        int vek;
        try {
            vek = Integer.parseInt(vekVeSkupineStr);
        } catch (NumberFormatException e) {
            throw new ValidationException(CHYBA);
        }
        if (vek < MIN_VEK || vek > MAX_VEK) {
            throw new ValidationException(CHYBA);
        }
        return new VekKlientu(vek);
    }
    private int vek;

    public VekKlientu(int vek) {
        this.vek = vek;
    }

    @Override
    public String toString() {
        return Integer.toString(getVek());
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (obj.getClass() != getClass()) {
            return false;
        }
        return ((VekKlientu) obj).getVek() == getVek();
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 71 * hash + getVek();
        return hash;
    }

    /**
     * @return the vek
     */
    public int getVek() {
        return vek;
    }
}
