package pobyty.model.turnus;

import org.smp.ValidationException;

public class Cena {

    public static int CENA_SIZE = 10;

    public static String colName() {
        return Cena.class.getSimpleName();
    }

    public static Cena validate(String cenaStr) throws ValidationException {
        int cena;
        if (cenaStr == null) {
            throw new ValidationException("Prosím vyplňte cenu.");
        }
        try {
            cena = Integer.parseInt(cenaStr.trim());
        } catch (NumberFormatException e) {
            throw new ValidationException("Neplatná cena.");
        }
        if (cena < 0) {
            throw new ValidationException("Neplatná cena.");
        }
        return new Cena(cena);
    }
    private int cena;

    public Cena(int cena) {
        this.cena = cena;
        if (cena < 0) {
            throw new IllegalArgumentException();
        }
    }

    @Override
    public String toString() {
        return Integer.toString(getCena());
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (obj.getClass() != getClass()) {
            return false;
        }
        return ((Cena) obj).getCena() == getCena();
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 71 * hash + getCena();
        return hash;
    }

    /**
     * @return the cena
     */
    public int getCena() {
        return cena;
    }
}
