package pobyty.model.uzivatel;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.smp.ValidationException;

public class Heslo {

    public static int HESLO_SIZE = 10;
    public static int MD5_SIZE = 32;

    public static String colName() {
        return Heslo.class.getSimpleName();
    }

    public static Heslo validate(String heslo) throws ValidationException {
        if (heslo == null) {
            throw new ValidationException("Heslo nesmí být prázdné.");
        }
        heslo = heslo.trim();
        if (heslo.isEmpty()) {
            throw new ValidationException("Heslo nesmí být prázdné.");
        }
        return new Heslo(md5(heslo));
    }

    public static String md5(String heslo) {
        try {
            byte[] b = MessageDigest.getInstance("MD5").digest(heslo.getBytes());
            return String.format("%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
                    b[0], b[1], b[2], b[3], b[4], b[5], b[6], b[7], b[8], b[9], b[10], b[11], b[12], b[13], b[14], b[15]);
        } catch (NoSuchAlgorithmException ex) {
            Logger.getLogger(Heslo.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }
    private String hesloMD5;

    public Heslo(String hesloMD5) {
        this.hesloMD5 = hesloMD5;
    }

    public String getHesloMDP() {
        return hesloMD5;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (obj.getClass() != this.getClass()) {
            return false;
        }
        return hesloMD5.equals(((Heslo) obj).hesloMD5);
    }

    @Override
    public int hashCode() {
        return 7 * hesloMD5.hashCode();
    }

    @Override
    public String toString() {
        return hesloMD5;
    }
}
