package pobyty.model.uzivatel;

import pobyty.model.Jmeno;
import pobyty.model.Osoba;
import pobyty.model.Prijmeni;

public class Uzivatel extends Osoba {

    public static final String USER = "user";
    private Username username;
    private RoleUzivatele roleUzivatele;
    private Heslo heslo;
    public static final Uzivatel KOORDINATOR = new Uzivatel(new Username("koordinator"));
    public static final Uzivatel ANONYM = new Uzivatel(new Username("anonym"));

    public Uzivatel(Username username) {
        this.username = username;
    }

    public Uzivatel(Username username, Prijmeni prijmeni, Jmeno jmeno, RoleUzivatele roleUzivatele, Heslo heslo) {
        super(prijmeni, jmeno);
        this.username = username;
        this.roleUzivatele = roleUzivatele;
        this.heslo = heslo;
    }

    /**
     * @return the username
     */
    public Username getUsername() {
        return username;
    }

    /**
     * @return the roleUzivatele
     */
    public RoleUzivatele getRoleUzivatele() {
        return roleUzivatele;
    }

    /**
     * @return the heslo
     */
    public Heslo getHeslo() {
        return heslo;
    }

    /**
     * @param heslo the heslo to set
     */
    public void setHeslo(Heslo heslo) {
        this.heslo = heslo;
    }

    @Override
    public String toString() {
        return username.getUsername();
    }
}
