package pobyty.stranky;

import java.util.List;
import org.smp.SmpException;
import org.smp.pages.Page;
import pobyty.business.Facade;
import pobyty.model.Datum;
import pobyty.model.Jmeno;
import pobyty.model.Mejl;
import pobyty.model.Mesto;
import pobyty.model.OsobaAdresa;
import pobyty.model.Prijmeni;
import pobyty.model.Psc;
import pobyty.model.Telefon;
import pobyty.model.Ulice;
import pobyty.model.klient.Indikace;
import pobyty.model.klient.KlientId;
import pobyty.model.klient.Kontraindikace;
import pobyty.model.prihlaska.StavPrihlasky;
import pobyty.model.skupina.VekKlientu;
import pobyty.model.turnus.Cena;
import pobyty.model.turnus.Kapacita;
import pobyty.model.turnus.Lokalita;
import pobyty.model.turnus.Turnus;
import pobyty.model.turnus.Zkratka;
import pobyty.model.uzivatel.Heslo;
import pobyty.model.uzivatel.RoleUzivatele;
import pobyty.model.uzivatel.Username;
import pobyty.model.uzivatel.Uzivatel;

public class AbstrPobytyStranka extends Page {

    public static boolean DEBUG = false;

    public int getDatumSize() {
        return Datum.DATE_SIZE;
    }

    public int getJmenoSize() {
        return Jmeno.JMENO_SIZE;
    }

    public int getKlientIdSize() {
        return KlientId.KLIENTID_SIZE;
    }

    public int getMejlSize() {
        return Mejl.MEJL_SIZE;
    }

    public int getMestoSize() {
        return Mesto.MESTO_SIZE;
    }

    public int getPrijmeniSize() {
        return Prijmeni.PRIJMENI_SIZE;
    }

    public int getPscSize() {
        return Psc.PSC_SIZE;
    }

    public int getTelefonSize() {
        return Telefon.TELEFON_SIZE;
    }

    public int getUliceSize() {
        return Ulice.ULICE_SIZE;
    }

    public int getVekKlientuSize() {
        return VekKlientu.VEKKLIENTU_SIZE;
    }

    public int getCenaSize() {
        return Cena.CENA_SIZE;
    }

    public int getKapacitaSize() {
        return Kapacita.KAPACITA_SIZE;
    }

    public int getLokalitaSize() {
        return Lokalita.LOKALITA_SIZE;
    }

    public int getZkratkaSize() {
        return Zkratka.ZKRATKA_SIZE;
    }

    public int getHesloSize() {
        return Heslo.HESLO_SIZE;
    }

    public int getUsernameSize() {
        return Username.USERNAME_SIZE;
    }

    public String getColNarozeni() {
        return OsobaAdresa.COLUMN_NAROZENI;
    }

    public StavPrihlasky[] getVycetStavuPrihlasky() {
        return StavPrihlasky.values();
    }

    public Indikace[] getVycetindikaci() {
        return Indikace.values();
    }

    public Kontraindikace[] getVycetkontraindikaci() {
        return Kontraindikace.values();
    }

    public List<Turnus> getTurnusy() throws SmpException {
        return Facade.getInstance().turnusy();
    }

    public Boolean getLogged() {
        return getRequest().getSession().getAttribute(Uzivatel.USER) != null;
    }

    public Uzivatel getLoggedUser() {
        Uzivatel u = (Uzivatel) getRequest().getSession().getAttribute(Uzivatel.USER);
        if (u == null) {
            u = Uzivatel.ANONYM;
        }
        return u;
    }

    public Boolean getJeKoordinator() throws SmpException {
        return getLoggedUser() == Uzivatel.KOORDINATOR;
    }

    public Boolean getJeLekar() throws SmpException {
        if (!getJeReferent()) {
            return false;
        }
        if (getJeKoordinator()) {
            return true;
        }
        return getLoggedUser().getRoleUzivatele() == RoleUzivatele.LEKAR;
    }

    public Boolean getJeReferent() throws SmpException {
        return getLoggedUser() != Uzivatel.ANONYM;
    }
}
