package pobyty.stranky.klientcast;

import java.util.ArrayList;
import java.util.List;
import org.smp.SmpException;
import pobyty.business.Facade;
import pobyty.model.turnus.Turnus;
import pobyty.stranky.AbstrPobytyStranka;

public abstract class AbstrKlientStranka extends AbstrPobytyStranka {

    public static class TurnusOption {

        Turnus turnus;

        public TurnusOption(Turnus turnus) {
            this.turnus = turnus;
        }

        @Override
        public String toString() {
            if (turnus == null) {
                return "vyber turnus";
            }
            return turnus.toString();
        }

        public String getTurnusOptionId() {
            if (turnus == null) {
                return "0";
            }
            return turnus.getTurnusId().toString();
        }
    }

    public List<TurnusOption> getTurnusyOption() throws SmpException {
        List<TurnusOption> turnusy = new ArrayList<>();
        turnusy.add(new TurnusOption(null));
        for (Turnus t : Facade.getInstance().turnusy()) {
            turnusy.add(new TurnusOption(t));
        }
        return turnusy;
    }

    @Override
    public String getTemplatePath() {
        return "/klientcast/KlientTemplate.xhtml";
    }
}
