package pobyty.stranky.referentcast.doprovod;

import java.util.Collections;
import java.util.List;
import javax.validation.ValidationException;
import org.smp.SmpException;
import pobyty.business.Facade;
import pobyty.model.doprovod.Doprovod;
import pobyty.model.doprovod.DoprovodId;
import pobyty.stranky.referentcast.AbstrReferentStranka;

public class TabDoprovod extends AbstrReferentStranka {

    public static final int CLIENT_COUNT = 30;

    @Override
    public void createContent() throws SmpException {
        List<Doprovod> doprovody = Collections.EMPTY_LIST;
        String parFiltrId = getParameter("filtrId");
        if (parFiltrId != null && !parFiltrId.trim().isEmpty()) {
            try {
                putItem("filtrId", parFiltrId);
                DoprovodId doprovodId = DoprovodId.validate(parFiltrId);

                Doprovod doprovod = Facade.getInstance().findDoprovod(doprovodId);
                if (doprovod == null) {
                    putItem("errorFiltrId", "Filtru neodpovídá žádný doprovod.");
                } else {
                    doprovody = Collections.singletonList(doprovod);
                }
            } catch (ValidationException ex) {
                putItem("errorFiltrId", "Neplatné ID.");
            }
        } else {
            String filtrPrijmeni = filtr(getParameter("filtrPrijmeni"));
            String filtrJmeno = filtr(getParameter("filtrJmeno"));
            doprovody = Facade.getInstance().doprovody(filtrPrijmeni, filtrJmeno);
            putItem("filtrPrijmeni", filtrPrijmeni);
            putItem("filtrJmeno", filtrJmeno);
        }
        sortOsobaAdresa(doprovody, getParameter("by"));
        putItem("doprovody", doprovody);
    }
}
