package pobyty.stranky.referentcast.klient;

import java.util.Collections;
import java.util.List;
import org.smp.SmpException;
import pobyty.business.Facade;
import pobyty.model.klient.Klient;
import pobyty.model.klient.KlientId;
import pobyty.stranky.referentcast.AbstrReferentStranka;

public class TabKlient extends AbstrReferentStranka {

    public static final int CLIENT_COUNT = 30;

    @Override
    public void createContent() throws SmpException {
        List<Klient> klienti = Collections.EMPTY_LIST;
        String parFiltrId = getParameter("filtrId");
        if (parFiltrId != null && !parFiltrId.trim().isEmpty()) {
            try {
                putItem("filtrId", parFiltrId);
                KlientId klientId = new KlientId(parFiltrId);
                Klient klient = Facade.getInstance().findKlient(klientId);
                if (klient == null) {
                    putItem("errorFiltrId", "Filtru neodpovídá žádný klient.");
                } else {
                    klienti = Collections.singletonList(klient);
                }
            } catch (NumberFormatException ex) {
                putItem("errorFiltrId", "Neplatné ID.");
            }
        } else {
            String filtrPrijmeni = filtr(getParameter("filtrPrijmeni"));
            String filtrJmeno = filtr(getParameter("filtrJmeno"));
            klienti = Facade.getInstance().klienti(filtrPrijmeni, filtrJmeno);
            putItem("filtrPrijmeni", filtrPrijmeni);
            putItem("filtrJmeno", filtrJmeno);
        }
        String by = getParameter("by");
        sortOsobaAdresa(klienti, by);
        putItem("klienti", klienti);
    }
}
